<html>
	<head>
		<title>Projet Groupe 36</title>
		<link rel="stylesheet" href="style.css" >
	</head>
	<body>

        <style>       
            .decalage-image {
              margin-left: 20px;
            }
			.decalage-image2 {
              margin-left: 100px;
            }
			.decalage-image3 {
              margin-left: 350px;
            }
          </style>
		<h1 style="text-align: center;">Jeu avec apprentissage de règles <br></h1>
		<a href="index.html">Retourner a la page principale<br></a>
		

		<h2 style="text-align: center;"><br></h2>

		<img src="res/heros1.png" width="288" height="288"class="decalage-image3"   />
		<img src="res/dodo5.png" width="288" height="288" class="decalage-image2"  />
		<p></p>
        <U><h2 style="text-align: center;">Présentation du jeu <br></h2></U>
        
        <h3>Vous êtes plongé dans une salle entourée de lave avec un fort brouillard par conséquent vous <br>ne voyez pas à plus de 2 métres!<br></h3>
        <h3>Si vous faites un pas de travers et que vous vous retrouvez nez à nez avec un monstre il vous prendra en chasse!<br>
			À noter que les monstres sont très efficaces dans leur traque mais ils sont aussi très vite épuisés.<br></h3>
        
        <h3>But du jeu: trouver la sortie!<img src="res/sortie.png"width="72" height="72"class="decalage-image"><br></h3>
        
        <br>
        <br>

		<U><h2 style="text-align: center;">Organisation de la semaine<br></h2></U>
		

		<h4>Lundi : Mise en forme du sujet, création du plateau de jeu et premières fonctions pour le déplacement<br></h4>
        <h4>Mardi : Suite des fonctions pour le déplacement du héros et des monstre, mise en place de la SDL<br></h4>
		<h4>Mercredi : Optimisation de l'IA, du déplacement des monstres et de la SDL<br></h4>
        <h4>Jeudi : Optimisation de l'IA, et mise en place du site web pour la deuxième semaine de projet<br></h4>
        <h4>Vendredi : Optimisation de l'IA, Editeur de niveau, Lave adaptative.</h4>

		<center><img src="stat_day.png" alt="Animation faite par Corentin" width="590" height="443""  /></center>


		<U><h2 style="text-align: center;">Création Du Jeu</code><br></h2></U>
	<h3><U>Génération de la carte:<br></U></h3>
	<img src="res/map_graphi.gif" alt="Animation faite par Corentin" width="500" 
		height="400"class="decalage-image2"  />
	<img src="matrice_carte.png" alt="Animation faite par Corentin" width="700" 
		height="400"class="decalage-image"  />

		<pre><code class="language-c">
void mur_carte(carte_t *map, float pourcentage_mur_ajoute)
{
    int nombre_de_mur = (int)(map->width * map->height * pourcentage_mur_ajoute); // On construit environ pourcentage_mur_ajoute% de mur sur la map
    int nombre_de_mur_construit = 0; // Constante pour voir le nombre de murs que l'on a déjà construit

    while ( nombre_de_mur_construit <= nombre_de_mur)
    {
        int mur_a_ajouter = 1 + (int)( max(map->height, map->width) * (double)rand() / RAND_MAX);
        
        construction_mur(mur_a_ajouter, map);
        nombre_de_mur_construit += mur_a_ajouter;
    }
}
		</code></pre>

		<U><h2 style="text-align: center;"> Editeur de niveau</h2></U>
		
	<center><img src="editeurDeNiveau.gif" alt="Editeur de niveau" width="500" 
		height="400"/></center>
		
		
		<U><h2 style="text-align: center;">Texture de lave adaptative</h2></U>
		
	<center><img src="frise.png" alt="Frise des textures de lave" width="856" 
		height="90"/></center>
		
		
		
		
		
		
		
		
		
		
		
		<h3><U>Gestion des monstres:<img src="res/dodo5.png"width="72" height="72"class="decalage-image3" > <br></U></h3>

		<pre><code class="language-c"></code>
			typedef struct monstre{
				int Mtype;
				int Mstate; // 0 endormi, 1 en chasse, -1 mort
				int Mmotiv; // de 0 a n : nombre de tour ou il poursuit le joueur
				int Mx,My;
				int Mnum;
			} monstre_t;
		</code></pre>

		<h4>-Gestion de déplacement des monstres</h4>


		<center><img src="schéma monstre.png" alt="Animation faite par Corentin" width="700" 
		height="400"  /></center>
		<!--
<pre><code class="language-c"></code>
void Prochaine_etape2(joueur_t * joueur, monstre_t * monstre, carte_t carte) 
{
	int mx = monstre->My, my = monstre->Mx;
	int jx = joueur->y, jy = joueur->x;

	int dist = distance_carre(jx,jy,mx,my);

	int nouv_mx = mx;
	int nouv_my = my;

	if (carte.carte[mx][my-1]==0 && dist > distance_carre(jx,jy,mx,my-1))
	{
		nouv_my = my-1;
		nouv_mx = mx;
		
		dist = distance_carre(jx,jy,mx,my-1);
	}
	if (carte.carte[mx][my+1]==0 && dist > distance_carre(jx,jy,mx,my+1))
    {
        nouv_my = my+1;
        nouv_mx = mx;

        dist = distance_carre(jx,jy,mx,my+1);
    }

    if (carte.carte[mx+1][my]==0 && dist > distance_carre(jx,jy,mx+1,my))
    {
        nouv_mx = mx+1;
        nouv_my = my;
        
        dist = distance_carre(jx,jy,mx+1,my);
    }
	if (carte.carte[mx-1][my]==0 && dist > distance_carre(jx,jy,mx-1,my))
    {
        nouv_mx = mx-1;
        nouv_my = my;
        
        dist = distance_carre(jx,jy,mx-1,my);
    }
    monstre->My = nouv_mx;
    monstre->Mx = nouv_my;
}
</code></pre>
-->
<p></p>
<center><img src="poursuite.gif" alt="Animation faite par Corentin" width="600" 
	height="300"  /></center>
<p></p>
		<h4>-Detection et réveil<img src="res/ezgif.com-gif-maker.gif"width="72" height="72"></h4>
		<center><img src="schéma_reveil.png" alt="Animation faite par Corentin" width="1000" 
			height="400""  /></center>
			<p></p>
			
		<!--
<pre><code class="language-c">
void Update_carte2(carte_t * carte, monstre_cell_t * headp, joueur_t joueur, sortie_t sortie)
{
	monstre_cell_t * cour = headp;
	int i = 0;
	while(cour)
	{
		i++;
		monstre_t *mons = cour->monstre;

		if(mons->Mstate == 1)
		{
			carte->carte[mons->Mx][mons->My] = 0;
			proteg_sortie(carte, sortie);
			Prochaine_etape2(&joueur, mons, *carte);
			deproteg_sortie(carte, sortie);
		}
		else if(mons->Mstate == 0){
			mons->Mstate = estJoueurDetecte(mons, &joueur);
		}

		carte->carte[mons->Mx][mons->My] = 3;
	
		cour = cour->suiv;
	}
}
</code></pre>
-->

<h4>-Placement des monstres, de la sortie et du joueur</h4>
<p> -On commence par placer aléatoirement les monstres sur la carte<br>
-On place la sortie et le joueur<br>
-On vérifie qu'il existe bien un chemin entre la sortie et le joueur(avec l'algorithme de Dijkstra)<br>
-Si ce n'est pas le cas, on replace le joueur et la sortie et on revérifie jusqu'à obtention d'une bonne configuration</p>

<style>
        .image-container {
            display: flex;
            justify-content: center;
            align-items: center;
        }

        .image-container img {
            margin: 10px;
        }
    </style>
<p></p>
<h3><U>Présentation des structures principales:<br></U></h3>
<a href="Semaine2/main.exe">Lancement du jeu<br></a>
<div class="image-container">
        <img src="dansLobscurite.gif" alt="Animation faite par Corentin">
        <img src="res/percep.png" alt="Perception du joueur">
    </div>
		<pre><code class="language-c">

typedef struct regle{           typedef struct joueur{                    typedef struct monstre{
	int **perception;	        int x,y;		              int Mtype;
	int *action;                    int nRegle;			    	  int Mstate; // 0 endormi, 1 en chasse, -1 mort	
	int *priorite;                  regle_t **listeRegle;                     int Mmotiv; 
}regle_t;                      	        int etat; //1 si en vie, 0 sinon          int Mx,My;
                                } joueur_t  					  int Mnum;
									  } monstre_t;
		</code></pre>
		<style>
        .text-image-container {
            display: flex;
            align-items: center;
            margin-right: 10px;
        }

        .text-image-container span {
            margin-right: 100px;
        }
    </style>

<<<<<<< HEAD
		<p><div class="text-image-container">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Les actions réalisables par le héros : <img src="res/action2.png"width="250" height="250"class="decalage-image"></div></p>
=======
		<p><div class="text-image-container">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Les actions réalisables par le héros : <img src="res/action.png"width="200" height="200"class="decalage-image">&nbsp;&nbsp;&nbsp;&nbsp;Les valeurs prises par les perceptions : <img src="perception_numero.png"width="200" height="200"class="decalage-image"></div></p>
>>>>>>> 829dd7c10e079edc9c160a0cf4b177cc77f1890c
		<h3><img src="res/heros1.png"width="72" height="72"><U>Algorithmes de choix des régles à suivre par l'IA:<br></U></h3>
		<h4>-Tirer une v.a. selon une loi tabulée</h4>
		<pre><code class="language-c">
int choix_de_la_regle3(joueur_t *joueur, int tableau_ressemblance[])
{
	double s = 0;
	int tab[joueur->nRegle];
	int indice_tab = 0;

	for (int i = 0; i < joueur->nRegle; i++)
	{
		if(tableau_ressemblance[i] == 1)
		{
			s += pow(joueur->listeRegle[i].priorite, s);
			tab[indice_tab] = i;
			indice_tab ++;
		}
	}
	double alpha = (double)rand() / ((double)RAND_MAX + 1);
	double somme = 0;
	for (int i = 0; i < indice_tab ; i++)
		somme += pow(joueur->listeRegle[tab[i]].priorite, s);
	indice_tab = 0;
	double cummul = pow(joueur->listeRegle[tab[indice_tab]].priorite, s) / somme;
	while(alpha > cummul / somme)
	{
		indice_tab ++;
		cummul += pow(joueur->listeRegle[tab[indice_tab]].priorite, s) / somme;
	}
	return joueur->listeRegle[tab[indice_tab]].action;
}
		</code></pre>
		<br>
		<h4>-Tirer une régle en fonction de sa priorité</h4>
		<pre><code class="language-c">

	     Règles de l'ia:

		[0]  9 9 9 9 9 9 9 9 9 -> 1 (1)
		[1]  9 9 0 0 9 9 9 9 9 -> 3 (2)
		[2]  9 9 9 1 9 2 9 9 9 -> 1 (1)
		[3]  9 9 9 0 9 3 9 2 9 -> 4 (3)
		
		
	     1) On calcule la somme des priorités des règles valides.
		
		[0]  9 9 9 9 9 9 9 9 9 -> 1 (1)	<- Regle valide
		[1]  9 9 0 0 9 9 9 9 9 -> 3 (2)	<- Regle valide
		[2]  9 9 9 1 9 2 9 9 9 -> 1 (1)
		[3]  9 9 9 0 9 3 9 2 9 -> 4 (3)	<- Regle valide
		
		somme = 1 + 2 + 3 = 6
		
	     2) On créer un tableau de taille la somme trouvée avant.
		
	     3) Pour chaque règle valide, on l'insère autant de fois que son nombre de priorité dans le tableau.
		
		[ 0 1 1 3 3 3 ]
		
	     4) On tire une règle au hasard dans ce tableau

		         _
		[ 0 1 1 |3| 3 3 ]
		         ‾
		Exemple, on prend l'indice 3 : règle 3 choisie.

		</code></pre>
		<br>

		<h3><U>Optimisation de l'IA:<br></U></h3>
		
		
		<h4>-Calcul du score </h4>
		
		<pre><code>
		
	Le calcul du score est un élément essentiel pour le bon apprentissage de l'ia.
	L'objectif est ici de minimiser le score.
	
		
		L'ia a trouvé la sortie : 
		
			Score = 0;
		
		L'ia n'a pas trouvé la sortie au bout du maximum d'itérations :
		
			Score = distance entre l'ia et la sortie
			
		L'ia a été mangé par un monstre :
			
			Score = nbrIterationRestantes + distance + malus
			
			
		
		</code></pre>
		
		<h4>-Une première version</h4>
		<pre><code class="language-c">
void amelioration_regles(int nombre_iteration, int nombre_perception, int nombre_de_monstre)
{
	//génération de la carte, et des paramètres du joueur
	for (int i = 0; i < nombre_iteration; i++)
	{
		int N = J->nRegle * (nombre_perception + 1 + 1);
        	int vecteur_regle[N];
		// Initialisation du vecteur de regle
	
		// On prend 4 nombres aleatoires correspondant aux 4 paramètres qui vont être modifiés
		for (int j = 0; j < 4; j ++)// boucle des 4 regles à modif
    	{
			//On sélectionne les 4 autres variantes de ce paramètre
		}
		for (int v = 0; v < 100 ; v++)
		{
			printf("v : %d\n", v);
			p_suivi[8 * j] += execution(simul_1);
			p_suivi[8 * j + 2] += execution(simul_2);
			p_suivi[8 * j + 4] += execution(simul_3);
			p_suivi[8 * j + 6] += execution(simul_4);
		} 
	}
	//choix de la régle avec le plus petit score
	modif_regles(J, meilleure_regle, valeur_de_la_modif, nombre_perception);
}
		</code></pre>
		<br>
		<h4>-Une seconde version</h4>
		<pre><code class="language-c">
		
		
	     1) On choisit une règle au hasard.
		
	     2) On choisit un paramètre dans cette règle. Ce peut être une perception, une action ou une priorité.

	     3) On test toutes les valeurs possibles de ce paramètre.

	     4) Pour chaque valeur du paramètre on simule plusieurs fois une partie pour calculer un score moyen.

	     5) On retient la valeur du paramètre qui donne le meilleur score.
		
		
		
		Problème : les règles ainsi générées ne sont pas forcément appliquées, le score ne dépend donc pas toujours
		de la valeur du paramètre.
		
		Exemple: 9 9 2 9 9 2 9 9 2 -> 2 (2)
		
		Cette règle est impossible car il ne peut pas y avoir 3 sortie.
		
		Solution proposée : Il faut une amélioration du score pour qu'il y ait changement de la valeur du paramètre.
		
		Nous avons également mit une probabilité pour qu'une mauvaise valeur du paramètre puisse quand même être adopté.
		
		Au lieu de prendre une règle et un paramètre au hasard, nous avons mit en place un algorithme qui mélange les règles
		et les paramètres.
		Ensuite nous prenons tous les paramètres en appliquant l'algorithme précédent.
		
		Nous avons aussi donné quelques règles qui lui sont immuables pour faciliter son apprentissage.
		
		
		for(i = 0; i< nPossibilite; i++){					// Pour i dans toutes les valeurs possibles du paramètre
			for(j=0; j< tailleGroupe; j++){					// Pour j dans la taille du groupe d'éxécution
				scoreMoyen+=execution(simuTmp);				// 'execution' renvoie le score fait par l'ia
			}
			scoreListe[i] = scoreMoyen/tailleGroupe;			// On enregistre le score fait par cette valeur du paramètre
		}	
		
		
		</code></pre>
		
		<style>
			.texte-aligne-gauche {
			  text-align: left;
			}
		  </style>
		<h3><U>Pistes d'amélioration du code:</U></h3>
		
			<p>-Retirer les perceptions sur les diagonales
			<br><br>-Rajouter une perception pour indiquer la distance avec la sortie: proche / moyenne / loin
<br><br>
		-L'algorithme de l'IA
			<br><br>-Trouver un système pour que le héros parcours toute la carte et ne revienne pas sur ses pas</p>
		<br><h3><U>Pistes d'amélioration du jeu:<br></U></h3>
		<p> Pour modifier le jeu nous pourrions ajouter une "motivation" aux monstres pour qu'ils s'arrêtent de poursuivre le joueur après un certain temps.<br> Nous pourrions également mettre plusieurs types de monstre qui auraient chacun leurs propres méthode de recherche de chemin. </p>
		<br><br><br>
		<a href="index.html">Retourner a la page principale<br></a><br><br>
	</body>
</html>
